package JavaBasics;

/************************************************
 * Play game "Gamblers Ruin", report statistics
 *  
 * usage:
 * 		java Gambler  <stake> <goal> <trials>
 * example:
 * 		java Gambler  5 25 1000
 * 
 * revisions:
 * 		2007-10-25 (jpr)
 ************************************************/

public class Gambler {
	public static void main(String[] args) {
		int stake  = Integer.parseInt(args[0]);
		int goal   = Integer.parseInt(args[1]);
		int trials = Integer.parseInt(args[2]);
		int wins   = 0;

		// repeat experiment N times
		for (int i = 0; i < trials; i++) {
			// do one gambler's ruin experiment
			int t = stake;
			while (t > 0 && t < goal) {
				// flip coin and update
				if (Math.random() < 0.5) t++;
				else                     t--;
			}
			if (t == goal) wins++;
		}
		System.out.println(wins + " wins of " + trials);
	}
}
