package JavaBasicsII.Percolation;
import pi1.*;

/*************************************************************************
 *
 *  Repeatedly generated N-by-N boolean matrices, where each site
 *  is true with probability p, and compute the probability that
 *  the system percolates.
 *
 *  Usage:
 *  	% java Estimate N p trials
 *  
 *  Example:
 *  	% java Estimate 16 .8 10000
 *
 *************************************************************************/


public class Estimate {

    // do M trials and return fraction that percolate
    public static double eval(int N, double p, int trials) {
        int count = 0;
        for (int k = 0; k < trials; k++) {
            boolean[][] open = BooleanMatrix.random(N, p);
            
            if (Percolation.percolates(open))
            //if (DirectedPercolation.percolates(open))
            //if (VerticalPercolation.percolates(open))
                count++;
        }
        return (double) count / trials;
    }


    public static void main(String[] args) {
        int    N = Integer.parseInt(args[0]);
        double p = Double.parseDouble(args[1]);
        int    trials = Integer.parseInt(args[2]);
        double q = eval(N, p, trials);
        StdOut.println(q);
    }
}
