package JavaBasicsII.Percolation;
import pi1.*;

/*************************************************************************
*
*  Usage:
*  		java VerticalPercolation < input.txt
*
*  Example:
*  		% java VerticalPercolation < testT.txt
*  		true
*  
*		% java VerticalPercolation < testF.txt
*		false
*
----- testT.txt
5
0 1 1 0 1
0 0 1 1 1
1 1 0 1 1
1 0 0 0 1
0 1 1 1 1

----- testF.txt
5
1 0 1 0 0
1 0 1 1 1
1 1 1 0 1
1 0 0 0 1
0 0 0 1 1 

*************************************************************************/

public class VerticalPercolation  { 

   // given an N-by-N matrix of open sites, return an N-by-N matrix
   // of sites reachable from the top
   public static boolean[][] flow(boolean[][] open) {
       int N = open.length;
       boolean[][] full = new boolean[N][N];
       
       for (int j = 0; j < N; j++)
           full[0][j] = open[0][j];
       
       for (int i = 1; i < N; i++)
    	      for (int j = 0; j < N; j++)
    	         full[i][j] = open[i][j] && full[i-1][j];

       return full;
   }

   // does the system percolate down
   public static boolean percolates(boolean[][] open) {
       boolean[][] full = flow(open);
       int N = full.length;
       for (int j = 0; j < N; j++)
           if (full[N-1][j]) return true;
       return false;
   }

   // test client
   public static void main(String[] args) {
       boolean[][] open = BooleanMatrix.read();
       BooleanMatrix.print(flow(open));
       StdOut.println(percolates(open));
   }
}
