package JavaBasicsII;
import pi1.*;

/*******************************************
5
0,02000 0,92000 0,02000 0,02000 0,02000 
0,02000 0,02000 0,38000 0,38000 0,20000 
0,02000 0,02000 0,02000 0,92000 0,02000 
0,92000 0,02000 0,02000 0,02000 0,02000 
0,47000 0,02000 0,47000 0,02000 0,02000

 *******************************************/

public class RandomSurfer {
    public static void main(String[] args) {
        int T = 100000;                         // number of moves
        int N = StdIn.readInt();              // number of pages

        // Read transition matrix.
        double[][] p = new double[N][N];     // p[i][j] = prob. that surfer moves from page i to page j
        for (int i = 0; i < N; i++)
            for (int j = 0; j < N; j++) 
                p[i][j] = StdIn.readDouble(); 

        int[] freq = new int[N];   // freq[i] = # times surfer hits page i
        int page = 0; // Start at page 0.

        for (int t = 0; t < T; t++) {
            // Make one random move. 
            double r = Math.random(); 
            double sum = 0.0; 
            for (int j = 0; j < N; j++) 
            {
                // Find interval containing r. 
                sum += p[page][j]; 
                if (r < sum) { page = j; break; } 
            } 
            freq[page]++; 
        } 
        // Print page ranks. 
        for (int i = 0; i < N; i++) {
            System.out.println( i + "  " + ((double)freq[i] / T) ); 
        }
    }  
} 
