package JavaBasicsII;
import pi1.*;

/*************************************************************************
 *  Usage:
 *  	java SawTooth N
 *  
 *  Plot 2/pi [sin(1t)/1 + sint(2t)/2 + sin(3t)/3 + ... ].
 *  As you plot more and more terms, the wave converges to a sawtooth wave.
 *  
 *  Example:
 *  	java SawTooth 20
 *
 *************************************************************************/



public class SawTooth { 
    public static void main(String[] args) {
        int N = Integer.parseInt(args[0]);
        StdDraw.setCanvasSize(1400, 500);
        StdDraw.setXscale(0, 6 * Math.PI);
        StdDraw.setYscale(-2, 2);

        StdDraw.show(0);
        double xprev = 0.0;

        for (double t = 0.0; t <= 6*Math.PI; t+= 0.005) {
            double x = 0.0;
            for (int k = 1; k <= N; k++) {
                x += Math.sin(k*t) / k;
            }
            x = x * 2 / Math.PI;
            StdDraw.line(t - 0.005, xprev, t, x);
            xprev = x;
        }
        StdDraw.show(0);
    }
}

