package JavaBasicsII;
import pi1.*;

public class ToneSawtooth {	
	public static double saw(double t, int N) {
        double x = 0.0;
        for (int k = 1; k <= N; k++) {
            x += Math.sin(k*t) / k;
        }
        return x * 2 / Math.PI;
	}
	public static double[] generate(double hz, double seconds) {
		int SAMPLES_PER_SEC = 64000;
		int N = (int) seconds * SAMPLES_PER_SEC;
		double[] a = new double[N+1];
		for (int i = 0; i <= N; i++) {
			a[i] = saw(2* Math.PI * i * hz / SAMPLES_PER_SEC, 20);
		}
		return a;
	}
	public static void paint(double[] a)  {
		int N = 640;	// first 640 samples = first 10 millisecs	
		StdDraw.setXscale(0, N);
		StdDraw.setYscale(-2.0, +2.0);
		for (int i = 10; i <= N; i+=10)  // draw faster but less precise
			StdDraw.line(i-10, a[i-10], i, a[i]);
	}
	public static void play(double[] a)  {
		StdAudio.play(a);
	}

	public static void main(String[] args) {
		double h = 220.0;	// HZ   (try 100,400,800,2000)
		double t = 3.0;		// time in seconds
		
		double[] a = generate(h,t);
		paint(a);
		play(a);
		
	    // needed to terminate program - known Java bug
	    System.exit(0);
	}
}
